; Auteur : LSI
; Version de PB : 4
;
; Explication du programme :
; Crer une fentre totalement skinne (Le fond et les boutons)


; Si la librairie SkinWindow n'est pas installe, on met la librairie en include
CompilerIf Defined(SetLayeredWindow, #PB_Function) = 0
	IncludeFile "SkinWindow.pb"
	SkinWindow_Init()
CompilerEndIf



; Item du skin, le numro correspond  la couleur de l'item (Voir image "Exemple 4\Item.png"
#G_Plus = $7ED2ED
#G_Moins = $1D5D72
#G_Mul = $1FB7E9
#G_Div = $198AAF
#G_Point = $56A0A3
#G_0 = $7BE2E6
#G_1 = $72F5E1
#G_2 = $58B9AA
#G_3 = $43847A
#G_4 = $6FEDAD
#G_5 = $5CBA8A
#G_6 = $3A7D5B
#G_7 = $47DD6A
#G_8 = $3CBA5A
#G_9 = $299041
#G_Cos = $E910EC
#G_Sin = $C30FC5
#G_Tan = $9C0E9E
#G_Pi = $750B76
#G_Deg = $A41FF1
#G_Rad = $8717C7
#G_Egal = $0E0EF6
#G_Trace = $0E0EC9
#G_Fonctions = $7A7E16
#G_Graphique = $B0B51F
#G_Equation = $F53610
#G_EquationBordure = $F07158
#G_Resultat = $BB2F14
#G_ResultatBordure = $BA5C49
#G_Fermer = $E3EA20
#G_Fermer2 = $B1B800 ; Bouton de la seconde fentre

; Enumeration des gadgets
Enumeration
	#G_TestGadgetClassique
EndEnumeration


; Crer une fenetre skinne  partir des images du dossier "Exemple 4"
If CreateSkinWindowFromTheme(0, 0, 0, "Calculette", #PB_Window_ScreenCentered | #PB_Window_Invisible, 0, "Exemple 4\1")
	
	; Dfinition des textes des items
	SetSkinItemText(#G_Plus, "+")
	SetSkinItemText(#G_Moins, "-")
	SetSkinItemText(#G_Mul, "")
	SetSkinItemText(#G_Div, "/")
	SetSkinItemText(#G_0, "0")
	SetSkinItemText(#G_1, "1")
	SetSkinItemText(#G_2, "2")
	SetSkinItemText(#G_3, "3")
	SetSkinItemText(#G_4, "4")
	SetSkinItemText(#G_5, "5")
	SetSkinItemText(#G_6, "6")
	SetSkinItemText(#G_7, "7")
	SetSkinItemText(#G_8, "8")
	SetSkinItemText(#G_9, "9")
	SetSkinItemText(#G_Point, ".")
	SetSkinItemText(#G_Cos, "Cos")
	SetSkinItemText(#G_Sin, "Sin")
	SetSkinItemText(#G_Tan, "Tan")
	SetSkinItemText(#G_Pi, "Pi")
	SetSkinItemText(#G_Rad, "Rad")
	SetSkinItemText(#G_Deg, "Deg")
	SetSkinItemText(#G_Egal, "=")
	SkinItemToolTip(#G_Egal, "Calculer")
	SetSkinItemText(#G_Fonctions, "Fonctions")
	SetSkinItemText(#G_Graphique, "Graphique")
	
	; On lie l'tat de certain lement entre eux
	LinkSkinItem(#G_Resultat, #G_ResultatBordure)
	LinkSkinItem(#G_Equation, #G_EquationBordure)
	
	; On dsactive un Item
	DisableSkinItem(#G_7, 1)
	
	; On dfinie l'item #G_Resultat comme lement pertettant de dplacer la fentre
	; Dans tous les cas, le fond de la fentre permet de dplacer la fentre
	SkinItemMoveWindow(#G_Resultat, 1)
	
	; On change l'tat de l'lment #G_Rad
	SetSkinItemState(#G_Rad, 1)
	
	; On ajoute un gadget
	ComboBoxGadget(#G_TestGadgetClassique, SkinItemX(#G_Equation), SkinItemY(#G_Equation), SkinItemWidth(#G_Equation), SkinItemHeight(#G_Equation))
	For i = 1 To 10
		AddGadgetItem(#G_TestGadgetClassique, -1, "Item " + Str(i))
	Next
	
	HideSkinWindow(0, 0)
	; hideskinwindowgadget(0, 1)
	
	Repeat
		Event = WaitSkinWindowEvent()
		
		; Si on a le focus sur la fentre, on affiche l'cran dans l'tat actif
		If GetActiveSkinWindow() = 0
			SetSkinItemState(#G_Resultat, 1)
			SetSkinItemState(#G_Equation, 1)
		Else
			SetSkinItemState(#G_Resultat, 0)
			SetSkinItemState(#G_Equation, 0)
		EndIf
		
		Select EventSkinWindow() ; Fentre skinne qui a reu un vnement
			Case 0 ; Fentre principale
				
				Select EventSkinItem() ; Item appuy
					Case #G_Fermer
						Event = #PB_Event_CloseWindow
					Case #G_Rad
						SetSkinItemState(#G_Rad, 1)
						SetSkinItemState(#G_Deg, 0)
					Case #G_Deg
						SetSkinItemState(#G_Rad, 0)
						SetSkinItemState(#G_Deg, 1)
					Case #G_Moins
						DisableSkinWindow(0, 1)
						AddWindowTimer(0, 0, 4000)
					Case #G_7
						DisableSkinItem(#G_7, 0)
						DisableSkinItem(#G_8, 1)
						DisableSkinItem(#G_9, 0)
					Case #G_8
						DisableSkinItem(#G_7, 0)
						DisableSkinItem(#G_8, 0)
						DisableSkinItem(#G_9, 1)
					Case #G_9
						DisableSkinItem(#G_7, 1)
						DisableSkinItem(#G_8, 0)
						DisableSkinItem(#G_9, 0)
						
					Case #G_6, #G_5, #G_4
						CreateSkinWindowFromTheme(1, 0, 0, "Calculette 2", 0, 0, "Exemple 4\2")
				EndSelect
				
				Select Event
					Case #PB_Event_Timer
						Select EventTimer()
							Case 0
								RemoveWindowTimer(0, 0)
								DisableSkinWindow(0, 0)
						EndSelect
						
					Case #PB_Event_Gadget
						Select EventGadget()
								Case #G_TestGadgetClassique
									Debug GetGadgetState(#G_TestGadgetClassique)
						EndSelect
				EndSelect
				
			Case  1 ; Seconde fenetre
				Select EventSkinItem() ; Item appuy
					Case #G_Fermer2
						CloseSkinWindow(1)
				EndSelect
		EndSelect
		
		
	Until Event = #PB_Event_CloseWindow
	
EndIf
; jaPBe Version=3.10.9.849
; Build=0
; ProductName=%exe%
; ProductVersion=%date%
; CompanyName=LSI
; FileVersion=%date%
; InternalName=%exe%
; LegalCopyright=LSI
; OriginalFilename=%source%
; Web=http://www.lsi-dev.com
; Language=0x0000 Language Neutral
; FirstLine=23
; CursorPosition=68
; EnableUSER
; EnableThread
; EnableXP
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF