ProcedureDLL SetLayeredWindow(WindowID) ; Set #WS_EX_LAYERED window attribute
	SetWindowLong_(WindowID, #GWL_EXSTYLE, GetWindowLong_(WindowID, #GWL_EXSTYLE) | #WS_EX_LAYERED) ; Mettre l'attribut WS_EX_LAYERED  la fentre
EndProcedure
ProcedureDLL SetLayeredWindowAttributes(WindowID.i, Alpha.i, Color.i) ; Change window transparency (Set transparency level of all window or/and set one color invisible)
	Protected Parametre.i
	If Alpha > 0
		Parametre | #LWA_ALPHA
	Else
		Alpha = 0
	EndIf
	If Color > 0
		Parametre | #LWA_COLORKEY
	Else
		Color = 0
	EndIf
	SetLayeredWindowAttributes_(WindowID, Color, Alpha, Parametre)
EndProcedure

ProcedureDLL SetWindowShape(WindowID, ImageId) ; Set window shape from image
	Protected bmi.BITMAPINFO, Region_Temp, Region_Totale, Largeur, Hauteur
	
	GetObject_(ImageID, SizeOf(BITMAP), @bm.BITMAP)
	
	bmi\bmiHeader\biSize = SizeOf(BITMAPINFOHEADER)
	bmi\bmiHeader\biWidth = bm\bmWidth
	bmi\bmiHeader\biHeight = bm\bmHeight
	bmi\bmiHeader\biPlanes = 1
	bmi\bmiHeader\biBitCount = 32
	bmi\bmiHeader\biCompression = #BI_RGB
	
	Region_Totale = CreateRectRgn_(0, 0, bm\bmWidth, bm\bmHeight)
	
	mem = AllocateMemory(bm\bmWidth * bm\bmHeight * 4)
	If mem
		
		hdc = CreateCompatibleDC_(GetDC_(ImageID))
		If hdc
			GetDIBits_(hdc, ImageID, 0, bm\bmHeight, mem, @bmi, #DIB_RGB_COLORS) ; on envoie la liste dans l'image
			DeleteDC_(hdc)
		EndIf
		
		; On convertit la liste dans le bon format
		Largeur = bm\bmWidth - 1
		Hauteur = bm\bmHeight - 1
		Point = mem
		For y1 = 0 To Hauteur
			For x1 = 0 To Largeur
				If PeekL(Point) = $FF00FF
					x2 = x1
					While x2 < Largeur And PeekL(Point + 4) = $FF00FF
						x2 + 1
						Point + 4
					Wend
					Region_Temp = CreateRectRgn_(x1, Hauteur - y1, x2 + 1, Hauteur - y1 + 1) ; On retire le point de la region
					CombineRgn_(Region_Totale, Region_Totale, Region_Temp, #RGN_DIFF)
					DeleteObject_(Region_Temp)
					x1 = x2
				EndIf
				Point + 4
			Next
		Next
		
		FreeMemory(mem)
	EndIf
	
	SetWindowRgn_(WindowID, Region_Totale, 1) ; On applique la region
	DeleteObject_(Region_Totale) ; On efface la region
	
EndProcedure
ProcedureDLL SetWindowShape2(WindowID, ImageId, Color)
	Protected bmi.BITMAPINFO, Region_Temp, Region_Totale, Largeur, Hauteur
	
	GetObject_(ImageID, SizeOf(BITMAP), @bm.BITMAP)
	
	bmi\bmiHeader\biSize = SizeOf(BITMAPINFOHEADER)
	bmi\bmiHeader\biWidth = bm\bmWidth
	bmi\bmiHeader\biHeight = bm\bmHeight
	bmi\bmiHeader\biPlanes = 1
	bmi\bmiHeader\biBitCount = 32
	bmi\bmiHeader\biCompression = #BI_RGB
	
	Region_Totale = CreateRectRgn_(0, 0, bm\bmWidth, bm\bmHeight)
	
	; On inverse la couleur
	Color =((Color & $0000FF) << 16) |(Color & $00FF00) |((Color & $FF0000) >> 16)
	
	mem = AllocateMemory(bm\bmWidth * bm\bmHeight * 4)
	If mem
		
		hdc = CreateCompatibleDC_(GetDC_(ImageID))
		If hdc
			GetDIBits_(hdc, ImageID, 0, bm\bmHeight, mem, @bmi, #DIB_RGB_COLORS) ; on envoie la liste dans l'image
			DeleteDC_(hdc)
		EndIf
		
		; On convertit la liste dans le bon format
		Largeur = bm\bmWidth - 1
		Hauteur = bm\bmHeight - 1
		Point = mem
		For y1 = 0 To Hauteur
			For x1 = 0 To Largeur
				If PeekL(Point) = Color
					x2 = x1
					While x2 < Largeur And PeekL(Point + 4) = Color
						x2 + 1
						Point + 4
					Wend
					Region_Temp = CreateRectRgn_(x1, Hauteur - y1, x2 + 1, Hauteur - y1 + 1) ; On retire le point de la region
					CombineRgn_(Region_Totale, Region_Totale, Region_Temp, #RGN_DIFF)
					DeleteObject_(Region_Temp)
					x1 = x2
				EndIf
				Point + 4
			Next
		Next
		
		FreeMemory(mem)
	EndIf
	
	SetWindowRgn_(WindowID, Region_Totale, 1) ; On applique la region
	DeleteObject_(Region_Totale) ; On efface la region
	
EndProcedure

ProcedureDLL AlphaImageWindow(WindowID, ImageId) ; Set image as window background (32bits image support)
	Protected Image_HDC, Image_Bitmap.BITMAP, ContextOffset.POINT, Blend.BLENDFUNCTION, Image
	
	; Dimension de l'image
	GetObject_(ImageID, SizeOf(BITMAP), @Image_Bitmap)
	
	Image = CreateImage(#PB_Any, Image_Bitmap\bmWidth, Image_Bitmap\bmHeight, 32)
	StartDrawing(ImageOutput(Image))
		DrawingMode(#PB_2DDrawing_AlphaBlend)
		DrawAlphaImage(ImageID, 0, 0)
		DrawingMode(#PB_2DDrawing_AlphaChannel)
		DrawAlphaImage(ImageID, 0, 0)
	StopDrawing()
	
	; Chargement du HDC
	Image_HDC = CreateCompatibleDC_(#Null)
	Image_Ancienne = SelectObject_(Image_HDC, ImageID(Image))
	
	; L'image est mise en skin de la fentre
	Blend\SourceConstantAlpha = 255 ; niveau de transparence
	Blend\AlphaFormat = 1 ; Support de la couche alpha
	Blend\BlendOp = 0
	Blend\BlendFlags = 0
	UpdateLayeredWindow_(WindowID, 0, 0, @Image_Bitmap + 4, Image_HDC, @ContextOffset, 0, @Blend, 2)
	
	; Fermeture du HDC
	SelectObject_(Image_HDC, Image_Ancienne)
	DeleteDC_(Image_HDC)
	
	; Supression de l'image
	FreeImage(Image)
	
EndProcedure
ProcedureDLL AlphaImageWindow2(WindowID, ImageId, Alpha)
	Protected Image_HDC, Image_Bitmap.BITMAP, ContextOffset.POINT, Blend.BLENDFUNCTION, Image
	
	; Dimension de l'image
	GetObject_(ImageID, SizeOf(BITMAP), @Image_Bitmap)
	
	Image = CreateImage(#PB_Any, Image_Bitmap\bmWidth, Image_Bitmap\bmHeight, 32)
	StartDrawing(ImageOutput(Image))
		DrawingMode(#PB_2DDrawing_AlphaBlend)
		DrawAlphaImage(ImageID, 0, 0)
		DrawingMode(#PB_2DDrawing_AlphaChannel)
		DrawAlphaImage(ImageID, 0, 0)
	StopDrawing()
	
	; Chargement du HDC
	Image_HDC = CreateCompatibleDC_(#Null)
	Image_Ancienne = SelectObject_(Image_HDC, ImageID(Image))
	
	; L'image est mise en skin de la fentre
	Blend\SourceConstantAlpha = Alpha ; niveau de transparence
	Blend\AlphaFormat = 1 ; Support de la couche alpha
	Blend\BlendOp = 0
	Blend\BlendFlags = 0
	UpdateLayeredWindow_(WindowID, 0, 0, @Image_Bitmap + 4, Image_HDC, @ContextOffset, 0, @Blend, 2)
	
	; Fermeture du HDC
	SelectObject_(Image_HDC, Image_Ancienne)
	DeleteDC_(Image_HDC)
	
	; Supression de l'image
	FreeImage(Image)
	
EndProcedure

Enumeration 1
	#SkinWindow_Error_NoImage
	#SkinWindow_Error_ImageSize
	#SkinWindow_Error_ItemColor
	#SkinWindow_Error_OpenWindow
	#SkinWindow_Error_TooManyItem
EndEnumeration

ProcedureDLL SkinWindow_Init()
	Structure Structure_SkinWindow
		Id.i
		Gadget.i
		Image.i
		Image_Normal.i
		Image_Hot.i
		Image_Selected.i
		Image_SelectedHot.i
		Image_Disable.i
		Image_Item.i
		Focus.b
		Disable.b
		MoveX.l
		MoveY.l
	EndStructure
	Global NewList SkinWindow.Structure_SkinWindow()
	Structure Structure_ToolTip
		Window.i
		Text.s
	EndStructure
	Structure Structure_SkinItem
		Window.i
		Id.i
		Image_Normal.i
		Image_Hot.i
		Image_Selected.i
		Image_SelectedHot.i
		Image_Disable.i
		Text.s
		Font.i
		Font_Color.i
		Font_HotColor.i
		ToolTip.Structure_ToolTip
		Image.i
		Hot.b
		Focus.b
		State.b
		Disable.b
		Parent.i
		Rect.RECT
		Point.POINT
		MoveWindow.b
	EndStructure
	Global NewList SkinItem.Structure_SkinItem()
	Global EventSkinWindow.i, EventSkinItem.i, SkinWindowError.i
	Structure Structure_ColorList
		Item.i
		Text.s
	EndStructure
	Global NewList SkinItemColorList.Structure_ColorList()
	; Police
	Structure Structure_Font
		Size.l
		Id.i
	EndStructure
	Global NewList SkinItemFont.Structure_Font()
	
	; Police de Windows
	Global WindowDefaultFont.i, WindowDefaultFontSize.l, WindowDefaultFontName.s
	Protected ncm.NONCLIENTMETRICS
	ncm\cbSize = SizeOf(NONCLIENTMETRICS)
	SystemParametersInfo_(#SPI_GETNONCLIENTMETRICS, SizeOf(NONCLIENTMETRICS), @ncm, 0)
	WindowDefaultFontName = PeekS(@ncm\lfMessageFont\lfFaceName, 32)
	DC = GetDC_(0)
	WindowDefaultFontSize = Round(11 * 72 / GetDeviceCaps_(DC, #LOGPIXELSY), #PB_Round_Nearest)
	ReleaseDC_(0, DC)
	WindowDefaultFont = LoadFont(#PB_Any, WindowDefaultFontName, WindowDefaultFontSize, #PB_Font_HighQuality)
	WindowDefaultFont = FontID(WindowDefaultFont)
	AddElement(SkinItemFont())
	SkinItemFont()\Size = WindowDefaultFontSize
	SkinItemFont()\Id = WindowDefaultFont
	
	Structure Structure_SkintItemToolTip
		Info.TOOLINFO
		FontColor.i
		BackColor.i
	EndStructure
	Global SkinItemToolTip.Structure_SkintItemToolTip
	SkinItemToolTip\FontColor = GetSysColor_(#COLOR_INFOTEXT)
	SkinItemToolTip\BackColor = GetSysColor_(#COLOR_INFOBK)
EndProcedure

Procedure SkinWindow_Draw(Window)
	Protected *Item.Structure_SkinItem, ItemParent
	
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			
			StartDrawing(ImageOutput(SkinWindow()\Image))
				DrawingMode(#PB_2DDrawing_AlphaChannel)
				Box(0, 0, OutputWidth(), OutputHeight(), 0)
				DrawingMode(#PB_2DDrawing_AlphaBlend | #PB_2DDrawing_Transparent)
				
				; Fond de la fentre
				If SkinWindow()\Disable
					DrawAlphaImage(ImageID(SkinWindow()\Image_Disable), 0, 0)
				ElseIf SkinWindow()\Focus
					DrawAlphaImage(ImageID(SkinWindow()\Image_Hot), 0, 0)
				Else
					DrawAlphaImage(ImageID(SkinWindow()\Image_Normal), 0, 0)
				EndIf
				
				; Items
				ForEach SkinItem()
					If SkinItem()\Window = Window
						
						*Item = @SkinItem()
						
						If SkinItem()\Parent ; Recherche du parent si il existe
							ForEach SkinItem()
								If SkinItem()\Id = *Item\Parent
									Break
								EndIf
							Next
						EndIf
						
						If SkinItem()\Disable Or *Item\Disable Or SkinWindow()\Disable
							DrawAlphaImage(ImageID(*Item\Image_Disable), *Item\Rect\left, *Item\Rect\top)
						ElseIf SkinItem()\State And (SkinItem()\Hot Or *Item\Hot)
							DrawAlphaImage(ImageID(*Item\Image_SelectedHot), *Item\Rect\left, *Item\Rect\top)
						ElseIf SkinItem()\State
							DrawAlphaImage(ImageID(*Item\Image_Selected), *Item\Rect\left, *Item\Rect\top)
						ElseIf SkinItem()\Hot Or *Item\Hot
							DrawAlphaImage(ImageID(*Item\Image_Hot), *Item\Rect\left, *Item\Rect\top)
						Else
							DrawAlphaImage(ImageID(*Item\Image_Normal), *Item\Rect\left, *Item\Rect\top)
						EndIf
						
						If *Item\Text And *Item\Font <> 0
							DrawingFont(*Item\Font)
							If (*Item\Hot Or SkinItem()\Hot) And *Item\Disable = 0 And SkinItem()\Disable = 0 And SkinWindow()\Disable = 0
								Couleur = *Item\Font_HotColor
							Else
								Couleur = *Item\Font_Color
							EndIf
							DrawText(*Item\Rect\left +(*Item\Rect\right - *Item\Rect\left + 1 - TextWidth(*Item\Text)) / 2, *Item\Rect\top +(*Item\Rect\bottom - *Item\Rect\top + 1 - TextHeight(*Item\Text)) / 2, *Item\Text, $FF000000 | Couleur)
						EndIf
						
						If *Item\Image And IsImage(*Item\Image)
							DrawAlphaImage(ImageID(*Item\Image), *Item\Rect\left, *Item\Rect\top)
						EndIf
						
						If *Item\Parent
							ChangeCurrentElement(SkinItem(), *Item)
						EndIf
						
					EndIf
				Next
				
				
				
			StopDrawing()
			
			AlphaImageWindow(WindowID(SkinWindow()\Id), ImageID(SkinWindow()\Image))
			; Debug "Dessin " + Str(SkinWindow()\Id)
			
			Break
		EndIf
	Next
EndProcedure

Procedure SkinWindow_Event(Event)
	Protected WindowEvent, Affichage, Deplacement
	
	EventSkinWindow = -1
	EventSkinItem = -1
	
	EventWindow = EventWindow()
	
	ForEach SkinWindow()
		
		; Dplacement
		If SkinWindow()\MoveX >= 0
			If GetAsyncKeyState_(#VK_LBUTTON) <> 0
				ResizeWindow(SkinWindow()\Id, DesktopMouseX() - SkinWindow()\MoveX, DesktopMouseY() - SkinWindow()\MoveY, #PB_Ignore, #PB_Ignore)
				ResizeWindow(SkinWindow()\Gadget, DesktopMouseX() - SkinWindow()\MoveX, DesktopMouseY() - SkinWindow()\MoveY, #PB_Ignore, #PB_Ignore)
			Else
				SkinWindow()\MoveX = -1
			EndIf
		EndIf
		
		; Sous la souris
		MouseWindow = WindowFromPoint_(DesktopMouseX() | DesktopMouseY() << 32)
		
		; Focus de la fentre
		Select GetActiveWindow_()
			Case WindowID(SkinWindow()\Id)
				If SkinWindow()\Focus <> 1
					SkinWindow()\Focus = 1
					If GetAsyncKeyState_(#VK_LBUTTON) <> 0 And MouseWindow = WindowID(SkinWindow()\Id)
						Event = #WM_LBUTTONDOWN
					EndIf
					Affichage = 1
				EndIf
			Case WindowID(SkinWindow()\Gadget)
				If SkinWindow()\Focus <> 2
					SkinWindow()\Focus = 2
					Affichage = 1
				EndIf
			Default
				If SkinWindow()\Focus
					SkinWindow()\Focus = 0
					Affichage = 1
				EndIf
		EndSelect
		
		; Survol des items
		If SkinWindow()\Focus Or MouseWindow = WindowID(SkinWindow()\Id) Or GetAncestor_(MouseWindow, 2) = WindowID(SkinWindow()\Gadget)
			MouseOver = 1
		EndIf
		x = WindowMouseX(SkinWindow()\Id)
		y = WindowMouseY(SkinWindow()\Id)
		StartDrawing(ImageOutput(SkinWindow()\Image_Item))
			ForEach SkinItem()
				If SkinItem()\Window = SkinWindow()\Id
					If MouseOver And x >= SkinItem()\Rect\left And x <= SkinItem()\Rect\right And y >= SkinItem()\Rect\top And y <= SkinItem()\Rect\bottom And Point(x, y) = SkinItem()\Id
						If SkinItem()\Hot = 0
							SkinItem()\Hot = 1
							Affichage = 1
						EndIf
					Else
						If SkinItem()\Hot = 1
							SkinItem()\Hot = 0
							Affichage = 1
						EndIf
					EndIf
				EndIf
			Next
		StopDrawing()
		
		; Evnements
		If EventWindow = SkinWindow()\Id
			EventSkinWindow = SkinWindow()\Id
			
			Select Event
				Case #WM_LBUTTONDOWN ; Dplacement
					Deplacement = 1
					ForEach SkinItem()
						If SkinItem()\Window = SkinWindow()\Id And SkinItem()\Hot And SkinItem()\MoveWindow = 0
							Deplacement = 0
						EndIf
					Next
					If Deplacement
						SkinWindow()\MoveX = x
						SkinWindow()\MoveY = y
					EndIf
					
				Case #WM_LBUTTONUP
					SkinWindow()\MoveX = -1
					ForEach SkinItem()
						If SkinItem()\Window = SkinWindow()\Id And SkinItem()\Hot And SkinItem()\Disable = 0 And SkinWindow()\Disable = 0
							EventSkinItem = SkinItem()\Id ; Item appuy
							SkinItem()\Focus = 2 ; On donne le focus  cet item
						EndIf
					Next
					
			EndSelect
			
		ElseIf EventWindow = SkinWindow()\Gadget
			EventSkinWindow = SkinWindow()\Id
			
		EndIf
		
		; Rafraichir l'affichage
		If Affichage
			SkinWindow_Draw(SkinWindow()\Id)
		EndIf
		
		; Focus des items
		If EventSkinItem > 0
			ForEach SkinItem()
				If SkinItem()\Window = SkinWindow()\Id And SkinItem()\Focus > 0
					SkinItem()\Focus - 1
				EndIf
			Next
		EndIf
		
	Next
EndProcedure

Procedure Filtre_MelangeAlpha(x, y, CouleurSource, CouleurDestination)
	ProcedureReturn(CouleurSource & $00FFFFFF) |(Alpha(CouleurSource) * Alpha(CouleurDestination) / 255) << 24
EndProcedure

ProcedureDLL.i WaitSkinWindowEvent() ; Waits until an event has occurs on any of the opened windows (Skinned or not)
	Protected Event.i
	Event = WaitWindowEvent(50)
	SkinWindow_Event(Event)
	ProcedureReturn Event
EndProcedure
ProcedureDLL.i SkinWindowEvent() ; Check if an event has occured on any of the opened windows (Skinned or not)
	Protected Event.i
	Event = WindowEvent()
	SkinWindow_Event(Event)
	ProcedureReturn Event
EndProcedure
ProcedureDLL.i EventSkinWindow() ; Returns on which skinned window the event has occured
	ProcedureReturn EventSkinWindow
EndProcedure
ProcedureDLL.i EventSkinItem() ; Returns which skinned window item has been pushed
	ProcedureReturn EventSkinItem
EndProcedure

ProcedureDLL SkinItemRect(Item, *Rect.rect)  ; Return the RECT positions, in pixel, of the skinned item
	CopyMemory(@SkinItem()\Rect, @*Rect, SizeOf(rect))
EndProcedure
ProcedureDLL SkinItemX(Item) ; Return the X position, in pixel, of the skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Rect\left
		EndIf
	Next
EndProcedure
ProcedureDLL SkinItemY(Item) ; Return the Y position, in pixel, of the skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Rect\top
		EndIf
	Next
EndProcedure
ProcedureDLL SkinItemWidth(Item) ; Return the width in pixel, of the skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Rect\right - SkinItem()\Rect\left + 1
		EndIf
	Next
EndProcedure
ProcedureDLL SkinItemHeight(Item) ; Return the height, in pixel, of the skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1
		EndIf
	Next
EndProcedure
ProcedureDLL GetSkinItemState(Item) ; Get the state of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			If SkinItem()\Parent
				Item = SkinItem()\Parent
				ForEach SkinItem()
					If SkinItem()\Id = Item
						Break
					EndIf
				Next
			EndIf
			ProcedureReturn SkinItem()\State
		EndIf
	Next
EndProcedure
ProcedureDLL GetSkinItemHot(Item) ; Get the mouse over state of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			If SkinItem()\Parent
				Item = SkinItem()\Parent
				ForEach SkinItem()
					If SkinItem()\Id = Item
						Break
					EndIf
				Next
			EndIf
			ProcedureReturn SkinItem()\Hot
		EndIf
	Next
EndProcedure
ProcedureDLL GetSkinItemFont(Item) ; Get the font of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Font
		EndIf
	Next
EndProcedure
ProcedureDLL GetSkinItemFontColor(Item) ; Get the font color of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Font_Color
		EndIf
	Next
EndProcedure
ProcedureDLL GetSkinItemFontHotColor(Item) ; Get the font hot color of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Font_HotColor
		EndIf
	Next
EndProcedure
ProcedureDLL.s GetSkinItemText(Item) ; Get the text content of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn SkinItem()\Text
		EndIf
	Next
EndProcedure
ProcedureDLL IsSkinItem(Item) ; Tests if the given 'Item' is an initialized item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			ProcedureReturn #True
		EndIf
	Next
	ProcedureReturn #False
EndProcedure

ProcedureDLL LinkSkinItem(ParentItem, ChildItem) ; Link skinned items together, the children state will be the same of parent state
	ForEach SkinItem()
		If SkinItem()\Id = ChildItem
			SkinItem()\Parent = ParentItem
			SkinWindow_Draw(SkinItem()\Window)
			Break
		EndIf
	Next
EndProcedure

ProcedureDLL SetSkinItemFont(Item, FontID, Color, HotColor) ; Change the text font and color of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item Or Item = #PB_Default
			If FontID = #PB_Default
				SkinItem()\Font = WindowDefaultFont
			Else
				SkinItem()\Font = FontID
			EndIf
			If Color >= 0
				SkinItem()\Font_Color = Color
			EndIf
			If HotColor >= 0
				SkinItem()\Font_HotColor = HotColor
			EndIf
			SkinWindow_Draw(SkinItem()\Window)
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL SetSkinItemText(Item, Text.s) ; Change the text content of the specified skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			If SkinItem()\Text <> Text
				SkinItem()\Text = Text
				SkinWindow_Draw(SkinItem()\Window)
			EndIf
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL SetSkinItemImage(Item, Image) ; Draw image on the skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			If SkinItem()\Image = 0 Or IsImage(SkinItem()\Image) = 0
				SkinItem()\Image = CreateImage(#PB_Any, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1, 32)
			EndIf
			StartDrawing(ImageOutput(SkinItem()\Image))
				DrawingMode(#PB_2DDrawing_AlphaChannel)
				DrawAlphaImage(ImageID(SkinItem()\Image_Normal), 0, 0)
				DrawingMode(#PB_2DDrawing_CustomFilter)
				CustomFilterCallback(@Filtre_MelangeAlpha())
				If ImageDepth(Image) = 32
					DrawAlphaImage(ImageID(Image),(SkinItem()\Rect\right - SkinItem()\Rect\left + 1 - ImageWidth(Image)) / 2,(SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1 - ImageHeight(Image)) / 2)
				Else
					DrawImage(ImageID(Image),(SkinItem()\Rect\right - SkinItem()\Rect\left + 1 - ImageWidth(Image)) / 2,(SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1 - ImageHeight(Image)) / 2)
				EndIf
			StopDrawing()
			SkinWindow_Draw(SkinItem()\Window)
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL SetSkinItemState(Item, State) ; Change the skinned item current state
	Protected Affichage.i = -1
	ForEach SkinItem()
		If SkinItem()\Id = Item
			
			If SkinItem()\State <> State
				SkinItem()\State = State
				Affichage = SkinItem()\Window
			EndIf
			
			Item = SkinItem()\Id
			ForEach SkinItem()
				If SkinItem()\Parent = Item
					SkinItem()\State = State
				EndIf
			Next
			
			If Affichage >= 0
				; Debug "SetSkinItemState(" + Str(Item)
				SkinWindow_Draw(Affichage)
			EndIf
			
			Break
			
		EndIf
	Next
EndProcedure
ProcedureDLL SkinItemMoveWindow(Item, State) ; Allow to move window when you keep left mouse button down on this skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			SkinItem()\MoveWindow = State
			Item = SkinItem()\Id
			ForEach SkinItem()
				If SkinItem()\Parent = Item
					SkinItem()\MoveWindow = State
				EndIf
			Next
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL DisableSkinItem(Item, Disable) ; Disable or enable a skinned item
	ForEach SkinItem()
		If SkinItem()\Id = Item
			SkinItem()\Disable = Disable
			Item = SkinItem()\Id
			ForEach SkinItem()
				If SkinItem()\Parent = Item
					SkinItem()\Disable = Disable
				EndIf
			Next
			SkinWindow_Draw(SkinItem()\Window)
			Break
		EndIf
	Next
EndProcedure

ProcedureDLL SkinItemToolTip(Item, Text.s) ; Associate the specified text to the skinned item
	Protected Affichage
	ForEach SkinItem()
		If SkinItem()\Id = Item
			If SkinItem()\ToolTip\Text <> Text
				SkinItem()\ToolTip\Text = Text
				If Text = ""
					If SkinItem()\ToolTip\Window
						DestroyWindow_(SkinItem()\ToolTip\Window)
						SkinItem()\ToolTip\Window = 0
					EndIf
				Else
					If SkinItem()\ToolTip\Window = 0
						SkinItem()\ToolTip\Window = CreateWindowEx_(0, "ToolTips_Class32", "", 0, 0, 0, 0, 0, 0, 0, 0, 0)
					EndIf
					SkinItemToolTip\Info\cbSize = SizeOf(TOOLINFO)
					SkinItemToolTip\Info\uFlags = #TTF_SUBCLASS
					SkinItemToolTip\Info\hwnd = WindowID(SkinItem()\Window)
					SkinItemToolTip\Info\lpszText = @SkinItem()\ToolTip\Text
					CopyMemory(@SkinItem()\Rect, @SkinItemToolTip\Info\Rect, SizeOf(rect))
					SendMessage_(SkinItem()\ToolTip\Window, #TTM_ADDTOOL, 0, @SkinItemToolTip\Info)
					SendMessage_(SkinItem()\ToolTip\Window, #TTM_SETTIPTEXTCOLOR, SkinItemToolTip\FontColor, 0)
					SendMessage_(SkinItem()\ToolTip\Window, #TTM_SETTIPBKCOLOR, SkinItemToolTip\BackColor, 0)
					SendMessage_(SkinItem()\ToolTip\Window, #TTM_SETMAXTIPWIDTH, 0, 200)
					SetWindowPos_(SkinItem()\ToolTip\Window,#HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOMOVE | #SWP_NOSIZE)
				EndIf
			EndIf
			Break
		EndIf
	Next
EndProcedure

ProcedureDLL SetSkinItemToolTipColor(ColorType.l, Color.l) ; Change a color in skinned item tooltip
	Select ColorType
		Case #PB_Gadget_FrontColor
			SkinItemToolTip\FontColor = Color
		Case #PB_Gadget_BackColor
			SkinItemToolTip\BackColor = Color
	EndSelect
EndProcedure

ProcedureDLL GetActiveSkinWindow() ; Get active skinned window
	Protected Id.l
	Id = -1
	ForEach SkinWindow()
		If SkinWindow()\Focus
			Id = SkinWindow()\Id
		EndIf
	Next
	ProcedureReturn Id
EndProcedure
ProcedureDLL GetActiveSkinItem() ; Get active skinned item
	Protected Id.l
	Id = -1
	ForEach SkinWindow()
		If SkinWindow()\Focus
			ForEach SkinItem()
				If SkinItem()\Focus And SkinItem()\Window = SkinWindow()\Id
					Id = SkinItem()\Id
					Break
				EndIf
			Next
		EndIf
	Next
	ProcedureReturn Id
EndProcedure
ProcedureDLL GetHotSkinItem() ; Get hot skinned item
	Protected Id.l
	Id = -1
	ForEach SkinItem()
		If SkinItem()\Hot
			Id = SkinItem()\Id
			Break
		EndIf
	Next
	ProcedureReturn Id
EndProcedure

ProcedureDLL UseSkinWindowGadgetList(Window) ; Make the specified Skinned Window the current gadget list to add gadgets on it
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			UseGadgetList(WindowID(SkinWindow()\Gadget))
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL DisableSkinWindow(Window, Disable) ; Disable all user input to the skinned window
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			SkinWindow()\Disable = Disable
			DisableWindow(SkinWindow()\Gadget, Disable)
			SkinWindow_Draw(SkinWindow()\Id)
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL CloseSkinWindow(Window) ; Close skinned window
	ForEach SkinItem()
		If SkinItem()\Window = Window
			FreeImage(SkinItem()\Image_Normal)
			FreeImage(SkinItem()\Image_Hot)
			FreeImage(SkinItem()\Image_Selected)
			FreeImage(SkinItem()\Image_SelectedHot)
			FreeImage(SkinItem()\Image_Disable)
			If IsImage(SkinItem()\Image)
				FreeImage(SkinItem()\Image)
			EndIf
			If SkinItem()\ToolTip\Window
				DestroyWindow_(SkinItem()\ToolTip\Window)
			EndIf
			DeleteElement(SkinItem())
		EndIf
	Next
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			CloseWindow(SkinWindow()\Gadget)
			CloseWindow(SkinWindow()\Id)
			If IsImage(SkinWindow()\Image_Normal)
				FreeImage(SkinWindow()\Image_Normal)
			EndIf
			If IsImage(SkinWindow()\Image_Hot)
				FreeImage(SkinWindow()\Image_Hot)
			EndIf
			If IsImage(SkinWindow()\Image_Disable)
				FreeImage(SkinWindow()\Image_Disable)
			EndIf
			If IsImage(SkinWindow()\Image)
				FreeImage(SkinWindow()\Image)
			EndIf
			DeleteElement(SkinWindow())
			Break
		EndIf
	Next
EndProcedure
ProcedureDLL HideSkinWindow(Window, State) ; Hides or show the specified #Window
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			HideWindow(SkinWindow()\Id, State)
			HideWindow(SkinWindow()\Gadget, State)
		EndIf
	Next
EndProcedure
ProcedureDLL HideSkinWindowGadget(Window, State) ; Hides or show all gadgets of the specified #Window
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			HideWindow(SkinWindow()\Gadget, State)
		EndIf
	Next
EndProcedure
ProcedureDLL MoveSkinWindow(Window, x, y) ; Move skinned window
	ForEach SkinWindow()
		If SkinWindow()\Id = Window
			ResizeWindow(SkinWindow()\Id, x, y, #PB_Ignore, #PB_Ignore)
			ResizeWindow(SkinWindow()\Gadget, x, y, #PB_Ignore, #PB_Ignore)
		EndIf
	Next
EndProcedure

ProcedureDLL.i CreateSkinWindow(Window, x, y, Title.s, Flag, ParentID, Image_Normal, Image_Hot, Image_Selected, Image_SelectedHot, Image_Disable, Image_Item, Image_FontSize, Image_FontColorNormal, Image_FontColorHot) ; Create skinned window
	
	If IsWindow(Window)
		CloseSkinWindow(Window)
	EndIf
	
	If IsImage(Image_Normal) And IsImage(Image_Item)
		Largeur = ImageWidth(Image_Normal)
		Hauteur = ImageHeight(Image_Normal)
		If IsImage(Image_Hot) = 0
			Image_Hot = Image_Normal
		EndIf
		If IsImage(Image_Selected) = 0
			Image_Selected = Image_Normal
		EndIf
		If IsImage(Image_SelectedHot) = 0
			If IsImage(Image_Selected) = 0
				Image_SelectedHot = Image_Hot
			Else
				Image_SelectedHot = Image_Selected
			EndIf
		EndIf
		If IsImage(Image_Disable) = 0
			Image_Disable = Image_Normal
		EndIf
		If IsImage(Image_FontSize) = 0
			Image_FontSize = CreateImage(#PB_Any, Largeur, Hauteur)
			StartDrawing(ImageOutput(Image_FontSize))
				Box(0, 0, Largeur, Hauteur, RGB(90, 90, 90))
			StopDrawing()
		EndIf
		If IsImage(Image_FontColorNormal) = 0
			Image_FontColorNormal = CreateImage(#PB_Any, Largeur, Hauteur)
		EndIf
		If IsImage(Image_FontColorHot) = 0
			Image_FontColorHot = CreateImage(#PB_Any, Largeur, Hauteur)
		EndIf
		If ImageWidth(Image_Hot) = Largeur And ImageWidth(Image_Selected) = Largeur And ImageWidth(Image_SelectedHot) = Largeur And ImageWidth(Image_Disable) = Largeur And ImageWidth(Image_Item) = Largeur And ImageWidth(Image_FontSize) = Largeur And ImageWidth(Image_FontColorNormal) = Largeur And ImageWidth(Image_FontColorHot) = Largeur
			If ImageHeight(Image_Hot) = Hauteur And ImageHeight(Image_Selected) = Hauteur And ImageHeight(Image_SelectedHot) = Hauteur And ImageHeight(Image_Disable) = Hauteur And ImageHeight(Image_Item) = Hauteur And ImageHeight(Image_FontSize) = Hauteur And ImageHeight(Image_FontColorNormal) = Hauteur And ImageHeight(Image_FontColorHot) = Hauteur
				
				Invisible = Flag & #PB_Window_Invisible
				Flag =(Flag & ~(#PB_Window_Tool | #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_Maximize | #PB_Window_SizeGadget)) | #PB_Window_BorderLess | #WS_SYSMENU | #WS_MINIMIZEBOX | #PB_Window_Invisible
				Id = OpenWindow(Window, x, y, Largeur, Hauteur, Title, Flag, ParentID)
				If Id
					If Window = #PB_Any
						Window = Id
					EndIf
					Id2 = OpenWindow(#PB_Any, WindowX(Window), WindowY(Window), Largeur, Hauteur, Title, #PB_Window_BorderLess | #PB_Window_Invisible, WindowID(Window))
					If Id2
						
						SkinWindowError = 0
						
						AddElement(SkinWindow())
						SkinWindow()\Id = Window
						
						SkinWindow()\Gadget = Id2
						
						SkinWindow()\Image = CreateImage(#PB_Any, Largeur, Hauteur, 32)
						
						SkinWindow()\Image_Normal = CopyImage(Image_Normal, #PB_Any)
						SkinWindow()\Image_Hot = CopyImage(Image_Hot, #PB_Any)
						SkinWindow()\Image_Disable = CopyImage(Image_Disable, #PB_Any)
						SkinWindow()\Image_Item = CopyImage(Image_Item, #PB_Any)
						
						Largeur - 1
						Hauteur - 1
						
						; Recherche de la position des items
						Protected Dim Image.l(Largeur, Hauteur)
						Protected Dim Image_Masque.l(Largeur, Hauteur)
						StartDrawing(ImageOutput(Image_Item))
							DrawingMode(#PB_2DDrawing_AlphaBlend)
							For x = 0 To Largeur
								For y = 0 To Hauteur
									Image(x, y) = Point(x, y)
									Image_Masque(x, y) = Image(x, y)
								Next
							Next
						StopDrawing()
						
						Item_Compteur = 0
						
						For x = 0 To Largeur
							For y = 0 To Hauteur
								If Image(x, y) <> $FF000000 And Image(x, y) & $FF000000 = $FF000000
									ForEach SkinItem()
										If SkinItem()\Id = Image(x, y)
											SkinWindowError = #SkinWindow_Error_ItemColor
										EndIf
									Next
									AddElement(SkinItem())
									Item_Compteur + 1
									SkinItem()\Window = Window
									SkinItem()\Id = Image(x, y)
									SkinItem()\Point\x = x
									SkinItem()\Point\y = y
									SkinItem()\Rect\left = x
									SkinItem()\Rect\right = x
									SkinItem()\Rect\top = y
									SkinItem()\Rect\bottom = y
									SkinItem()\Image = -1
									For xx = 0 To Largeur
										For yy = 0 To Hauteur
											If Image(xx, yy) = SkinItem()\Id
												If xx < SkinItem()\Rect\left
													SkinItem()\Rect\left = xx
												EndIf
												If xx > SkinItem()\Rect\right
													SkinItem()\Rect\right = xx
												EndIf
												If yy < SkinItem()\Rect\top
													SkinItem()\Rect\top = yy
												EndIf
												If yy > SkinItem()\Rect\bottom
													SkinItem()\Rect\bottom = yy
												EndIf
												Image(xx, yy) = 0
											EndIf
										Next
									Next
									
									; Debug Str(SkinItem()\Id & $00FFFFFF) + " = RGB(" + Str(Red(SkinItem()\Id)) + ", " + Str(Green(SkinItem()\Id)) + ", " + Str(Blue(SkinItem()\Id)) + ")"
									; Debug "Position = " + Str(SkinItem()\Point\x) + " / " + Str(SkinItem()\Point\y)
									; Debug "Zone = [" + Str(SkinItem()\Rect\left) + ";" + Str(SkinItem()\Rect\top) + "] [" + Str(SkinItem()\Rect\right) + ";" + Str(SkinItem()\Rect\bottom) + "]"
									; Debug ""
									
								EndIf
							Next
						Next
						
						If Item_Compteur > 128
							SkinWindowError = #SkinWindow_Error_TooManyItem
						EndIf
						
						; Dcoupage des images des items
						ForEach SkinItem()
							If SkinItem()\Window = Window
								SkinItem()\Image_Disable = GrabImage(Image_Disable, #PB_Any, SkinItem()\Rect\left, SkinItem()\Rect\top, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1)
								StartDrawing(ImageOutput(SkinItem()\Image_Disable))
									DrawingMode(#PB_2DDrawing_AlphaChannel)
									For x = SkinItem()\Rect\left To SkinItem()\Rect\right
										For y = SkinItem()\Rect\top To SkinItem()\Rect\bottom
											If Image_Masque(x, y) <> SkinItem()\Id
												Plot(x - SkinItem()\Rect\left, y - SkinItem()\Rect\top, 0)
											EndIf
										Next
									Next
								StopDrawing()
								SkinItem()\Image_Normal = GrabImage(Image_Normal, #PB_Any, SkinItem()\Rect\left, SkinItem()\Rect\top, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1)
								StartDrawing(ImageOutput(SkinItem()\Image_Normal))
									DrawingMode(#PB_2DDrawing_AlphaChannel)
									For x = SkinItem()\Rect\left To SkinItem()\Rect\right
										For y = SkinItem()\Rect\top To SkinItem()\Rect\bottom
											If Image_Masque(x, y) <> SkinItem()\Id
												Plot(x - SkinItem()\Rect\left, y - SkinItem()\Rect\top, 0)
											EndIf
										Next
									Next
								StopDrawing()
								SkinItem()\Image_Hot = GrabImage(Image_Hot, #PB_Any, SkinItem()\Rect\left, SkinItem()\Rect\top, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1)
								StartDrawing(ImageOutput(SkinItem()\Image_Hot))
									DrawingMode(#PB_2DDrawing_AlphaChannel)
									For x = SkinItem()\Rect\left To SkinItem()\Rect\right
										For y = SkinItem()\Rect\top To SkinItem()\Rect\bottom
											If Image_Masque(x, y) <> SkinItem()\Id
												Plot(x - SkinItem()\Rect\left, y - SkinItem()\Rect\top, 0)
											EndIf
										Next
									Next
								StopDrawing()
								SkinItem()\Image_Selected = GrabImage(Image_Selected, #PB_Any, SkinItem()\Rect\left, SkinItem()\Rect\top, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1)
								StartDrawing(ImageOutput(SkinItem()\Image_Selected))
									DrawingMode(#PB_2DDrawing_AlphaChannel)
									For x = SkinItem()\Rect\left To SkinItem()\Rect\right
										For y = SkinItem()\Rect\top To SkinItem()\Rect\bottom
											If Image_Masque(x, y) <> SkinItem()\Id
												Plot(x - SkinItem()\Rect\left, y - SkinItem()\Rect\top, 0)
											EndIf
										Next
									Next
								StopDrawing()
								SkinItem()\Image_SelectedHot = GrabImage(Image_SelectedHot, #PB_Any, SkinItem()\Rect\left, SkinItem()\Rect\top, SkinItem()\Rect\right - SkinItem()\Rect\left + 1, SkinItem()\Rect\bottom - SkinItem()\Rect\top + 1)
								StartDrawing(ImageOutput(SkinItem()\Image_SelectedHot))
									DrawingMode(#PB_2DDrawing_AlphaChannel)
									For x = SkinItem()\Rect\left To SkinItem()\Rect\right
										For y = SkinItem()\Rect\top To SkinItem()\Rect\bottom
											If Image_Masque(x, y) <> SkinItem()\Id
												Plot(x - SkinItem()\Rect\left, y - SkinItem()\Rect\top, 0)
											EndIf
										Next
									Next
								StopDrawing()
								
								; on filtre la couche alpha pour l'ID de l'item
								SkinItem()\Id = SkinItem()\Id & $00FFFFFF
								
								; UsePNGImageEncoder()
								; SaveImage(SkinItem()\Image_Normal, Str(SkinItem()\Id) + ".png", #PB_ImagePlugin_PNG)
								
							EndIf
						Next
						
						; Taille de police
						StartDrawing(ImageOutput(Image_FontSize))
							ForEach SkinItem()
								If SkinItem()\Window = Window
									SkinItem()\Font = Red(Point(SkinItem()\Point\x, SkinItem()\Point\y)) / 10
								EndIf
							Next
						StopDrawing()
						ForEach SkinItem()
							If SkinItem()\Window = Window
								Size = SkinItem()\Font
								If Size > 0
									SkinItem()\Font = 0
									ForEach SkinItemFont()
										If SkinItemFont()\Size = Size
											SkinItem()\Font = SkinItemFont()\Id
										EndIf
									Next
									If SkinItem()\Font = 0
										SkinItem()\Font = LoadFont(#PB_Any, WindowDefaultFontName, Size, #PB_Font_HighQuality)
										SkinItem()\Font = FontID(SkinItem()\Font)
									EndIf
								EndIf
							EndIf
						Next
						
						; Couleur de police
						StartDrawing(ImageOutput(Image_FontColorNormal))
							ForEach SkinItem()
								If SkinItem()\Window = Window
									SkinItem()\Font_Color = Point(SkinItem()\Point\x, SkinItem()\Point\y)
								EndIf
							Next
						StopDrawing()
						
						; Couleur de police avec survol
						StartDrawing(ImageOutput(Image_FontColorHot))
							ForEach SkinItem()
								If SkinItem()\Window = Window
									SkinItem()\Font_HotColor = Point(SkinItem()\Point\x, SkinItem()\Point\y)
								EndIf
							Next
						StopDrawing()
						
						; Image de fond, on supprime les items
						StartDrawing(ImageOutput(SkinWindow()\Image_Disable))
							DrawingMode(#PB_2DDrawing_AlphaChannel)
							For x = 0 To Largeur
								For y = 0 To Hauteur
									If Image_Masque(x, y) <> $FF000000 And Image_Masque(x, y) & $FF000000 <> 0
										Plot(x, y, 0)
									EndIf
								Next
							Next
						StopDrawing()
						StartDrawing(ImageOutput(SkinWindow()\Image_Normal))
							DrawingMode(#PB_2DDrawing_AlphaChannel)
							For x = 0 To Largeur
								For y = 0 To Hauteur
									If Image_Masque(x, y) <> $FF000000 And Image_Masque(x, y) & $FF000000 <> 0
										Plot(x, y, 0)
									EndIf
								Next
							Next
						StopDrawing()
						StartDrawing(ImageOutput(SkinWindow()\Image_Hot))
							DrawingMode(#PB_2DDrawing_AlphaChannel)
							For x = 0 To Largeur
								For y = 0 To Hauteur
									If Image_Masque(x, y) <> $FF000000 And Image_Masque(x, y) & $FF000000 <> 0
										Plot(x, y, 0)
									EndIf
								Next
							Next
						StopDrawing()
						
						SetLayeredWindow(WindowID(Window))
						
						SetWindowColor(Id2, $FF00FF)
						SetLayeredWindow(WindowID(Id2))
						SetLayeredWindowAttributes(WindowID(Id2), -1, $FF00FF)
						
						SkinWindow()\MoveX = -1
						
						SkinWindow_Draw(Window)
						
						If Invisible = 0 And SkinWindowError = 0
							HideWindow(Window, 0)
							HideWindow(Id2, 0)
						EndIf
						If SkinWindowError
							CloseSkinWindow(Window)
							Id = 0
						EndIf
						; Debug "Fentre ouverte = " + Str(Window)
					Else
						CloseWindow(Window)
						Id = 0
						SkinWindowError = #SkinWindow_Error_OpenWindow
					EndIf
				Else
					SkinWindowError = #SkinWindow_Error_OpenWindow
				EndIf
				
			Else
				SkinWindowError = #SkinWindow_Error_ImageSize
			EndIf
		Else
			SkinWindowError = #SkinWindow_Error_ImageSize
		EndIf
	Else
		SkinWindowError = #SkinWindow_Error_NoImage
	EndIf
	ProcedureReturn Id
EndProcedure
ProcedureDLL.i CreateSkinWindowFromTheme(Window, x, y, Title.s, Flag, ParentID, ThemeDirectory.s) ; Create skinned window from theme
	Protected Image_Normal, Image_Hot, Image_Selected, Image_SelectedHot, Image_Disable, Image_Item, Image_FontSize, Image_FontColorNormal, Image_FontColorHot
	If Right(ThemeDirectory, 1) <> "\"
		ThemeDirectory + "\"
	EndIf
	UsePNGImageDecoder()
	Image_Normal = LoadImage(#PB_Any, ThemeDirectory + "Normal.png")
	Image_Hot = LoadImage(#PB_Any, ThemeDirectory + "Hot.png")
	Image_Selected = LoadImage(#PB_Any, ThemeDirectory + "Selected.png")
	Image_SelectedHot = LoadImage(#PB_Any, ThemeDirectory + "SelectedHot.png")
	Image_Disable = LoadImage(#PB_Any, ThemeDirectory + "Disable.png")
	Image_Item = LoadImage(#PB_Any, ThemeDirectory + "Item.png")
	Image_FontSize = LoadImage(#PB_Any, ThemeDirectory + "FontSize.png")
	Image_FontColorNormal = LoadImage(#PB_Any, ThemeDirectory + "FontColor.png")
	Image_FontColorHot = LoadImage(#PB_Any, ThemeDirectory + "FontHotColor.png")
	
	Id = CreateSkinWindow(Window, x, y, Title.s, Flag, ParentID, Image_Normal, Image_Hot, Image_Selected, Image_SelectedHot, Image_Disable, Image_Item, Image_FontSize, Image_FontColorNormal, Image_FontColorHot)
	
	If IsImage(Image_Normal)
		FreeImage(Image_Normal)
	EndIf
	If IsImage(Image_Hot)
		FreeImage(Image_Hot)
	EndIf
	If IsImage(Image_Selected)
		FreeImage(Image_Selected)
	EndIf
	If IsImage(Image_SelectedHot)
		FreeImage(Image_SelectedHot)
	EndIf
	If IsImage(Image_Disable)
		FreeImage(Image_Disable)
	EndIf
	If IsImage(Image_Item)
		FreeImage(Image_Item)
	EndIf
	If IsImage(Image_FontSize)
		FreeImage(Image_FontSize)
	EndIf
	If IsImage(Image_FontColorNormal)
		FreeImage(Image_FontColorNormal)
	EndIf
	If IsImage(Image_FontColorHot)
		FreeImage(Image_FontColorHot)
	EndIf

	
	ProcedureReturn Id
EndProcedure
ProcedureDLL.i CreateSkinWindowError() ; Get skinned window creation error
	ProcedureReturn SkinWindowError
EndProcedure

ProcedureDLL.i AddSkinItemColorList(Item, Text.s) ; Add item in color list to create new theme
	AddElement(SkinItemColorList())
	SkinItemColorList()\Item = Item
	SkinItemColorList()\Text = Text
EndProcedure
ProcedureDLL.i SaveSkinItemColorList(File.s); Save item color list to create new theme
	Protected Largeur, y
	UsePNGImageEncoder()
	Image = CreateImage(#PB_Any, 32, 32)
	StartDrawing(ImageOutput(Image))
		DrawingFont(WindowDefaultFont)
		Largeur = 0
		ForEach SkinItemColorList()
			y = TextWidth(SkinItemColorList()\Text)
			If y > Largeur
				Largeur = y
			EndIf
		Next
	StopDrawing()
	FreeImage(Image)
	Image = CreateImage(#PB_Any, 80 + Largeur, 24 * ListSize(SkinItemColorList()))
	StartDrawing(ImageOutput(Image))
		DrawingFont(WindowDefaultFont)
		y = 0
		ForEach SkinItemColorList()
			Box(0, y, 64, 24, SkinItemColorList()\Item)
			DrawText(72, y + (24 - TextHeight(SkinItemColorList()\Text)) / 2, SkinItemColorList()\Text, $FFFFFF)
			y + 24
		Next
	StopDrawing()
	ClearList(SkinItemColorList())
	ProcedureReturn SaveImage(Image, File, #PB_ImagePlugin_PNG)
EndProcedure

ProcedureDLL SkinWindow_End()
	ForEach SkinItem()
		FreeImage(SkinItem()\Image_Normal)
		FreeImage(SkinItem()\Image_Hot)
		FreeImage(SkinItem()\Image_Selected)
		FreeImage(SkinItem()\Image_SelectedHot)
		FreeImage(SkinItem()\Image_Disable)
		If IsImage(SkinItem()\Image)
			FreeImage(SkinItem()\Image)
		EndIf
		If SkinItem()\ToolTip\Window
			DestroyWindow_(SkinItem()\ToolTip\Window)
		EndIf
		DeleteElement(SkinItem())
	Next
	ForEach SkinWindow()
		CloseWindow(SkinWindow()\Gadget)
		CloseWindow(SkinWindow()\Id)
		If IsImage(SkinWindow()\Image_Normal)
			FreeImage(SkinWindow()\Image_Normal)
		EndIf
		If IsImage(SkinWindow()\Image_Hot)
			FreeImage(SkinWindow()\Image_Hot)
		EndIf
		If IsImage(SkinWindow()\Image_Disable)
			FreeImage(SkinWindow()\Image_Disable)
		EndIf
		If IsImage(SkinWindow()\Image)
			FreeImage(SkinWindow()\Image)
		EndIf
		DeleteElement(SkinWindow())
	Next
EndProcedure
; jaPBe Version=3.11.6.857
; FoldLines=0000000200030010001200440045007A007C009C009D00BD00BF00C500C800D6
; FoldLines=00D800DB00DC00F200FB00FE01100114011A016701E001E201E401E901F001F2
; FoldLines=01F301F501F701F901FA0200020102070208020E020F02150216022402250233
; FoldLines=0234023A023B0241024202480249024F02500257025902610263027502760280
; FoldLines=02810296029702B102B202BF02C002CE02D002EE02F002F702F9030203030311
; FoldLines=0312031C031E03250326032F033003550356035D035E03640365036C036E04AA
; FoldLines=04AB04DB04DC04DE04E004E405020522
; Build=0
; Manual Parameter T="D:\PureBasic\Dveloppements\Librairies\SkinWindow\SkinWindow.pb" "/CHM:SkinWindow.CHM"
; ProductName=%exe%
; ProductVersion=%date%
; CompanyName=LSI
; FileVersion=%date%
; InternalName=%exe%
; LegalCopyright=LSI
; OriginalFilename=%source%
; Web=http://www.lsi-dev.com
; Language=0x0000 Language Neutral
; FirstLine=192
; CursorPosition=1258
; EnableThread
; EnableXP
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF